'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _color = require('color');

var _color2 = _interopRequireDefault(_color);

var _fixedDataTable = require('fixed-data-table');

var _dataTableStyle = require('../vendor/dataTableStyle.js');

var _dataTableStyle2 = _interopRequireDefault(_dataTableStyle);

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _TableCell = require('./TableCell');

var _TableCell2 = _interopRequireDefault(_TableCell);

var _DataIconCell = require('./DataIconCell');

var _DataIconCell2 = _interopRequireDefault(_DataIconCell);

var _root = require('../root.js');

var _root2 = _interopRequireDefault(_root);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Cell = require('fixed-data-table').Cell;
Cell = (0, _radium2.default)(Cell);

var ComponentList = function (_Component) {
	_inherits(ComponentList, _Component);

	function ComponentList(props) {
		_classCallCheck(this, ComponentList);

		var _this = _possibleConstructorReturn(this, (ComponentList.__proto__ || Object.getPrototypeOf(ComponentList)).call(this, props));

		_initialiseProps.call(_this);

		var columnWidths = {
			changed: 20,
			name: 175,
			renderCount: 85,
			warningCount: 75
		};
		var tableWidth = 0;
		for (var name in columnWidths) {
			tableWidth += columnWidths[name];
		}
		var componentTableData = _this.getComponentTableData(props.entries);
		_this.state = {
			selectedComponentId: props.entries.first().get('id'),
			componentTableData: componentTableData,
			tableWidth: tableWidth,
			columnWidths: columnWidths,
			// The height must be set again
			// after the component has mounted and the window height is available
			maxTableHeight: null
		};
		return _this;
	}

	_createClass(ComponentList, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.updateDimensions();
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			var _this2 = this;

			_root2.default.getWindow().addEventListener("resize", this.updateDimensions);
			setTimeout(function () {
				_this2.setState({
					maxTableHeight: _this2.getMaxTableHeight()
				});
			}, 0);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			this.setState({
				componentTableData: this.getComponentTableData(nextProps.entries)
			});
		}
	}, {
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(nextProps, nextState) {
			return !(0, _shallowequal2.default)(this.props, nextProps) || !(0, _shallowequal2.default)(this.state, nextState);
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			_root2.default.getWindow().removeEventListener("resize", this.updateDimensions);
		}
	}, {
		key: 'render',
		value: function render() {

			var stylesheets = Object.assign({}, _dataTableStyle2.default);

			return _react2.default.createElement(
				'div',
				{ style: this.styles.container },
				_react2.default.createElement(_radium.Style, { rules: stylesheets }),
				_react2.default.createElement(
					'div',
					{ style: this.styles.heading },
					'Available Components'
				),
				this.getComponents()
			);
		}
	}]);

	return ComponentList;
}(_react.Component);

ComponentList.propTypes = {
	entries: _react.PropTypes.instanceOf(_immutable2.default.Map).isRequired,
	onChange: _react.PropTypes.func.isRequired
};

var _initialiseProps = function _initialiseProps() {
	var _this3 = this;

	this.rowHeight = 25;
	this.headerHeight = 25;
	this.styles = {
		container: {
			position: 'relative',
			padding: '10px'
		},
		heading: {
			marginBottom: '10px',
			fontSize: '14px',
			fontWeight: 'bold'
		},
		tableContainer: {
			boxShadow: '2px 2px 5px rgba(0, 0, 0, 0.5)'
		},
		table: {
			zIndex: '0'
		},
		cell: {
			display: 'flex',
			alignItems: 'center',
			flex: '1',
			height: '100%',
			cursor: 'pointer',
			opacity: '1',
			animation: 'x 1s ease-out',
			animationName: _radium2.default.keyframes({
				'0%': { opacity: '0' },
				'60%': { opacity: '0.7' },
				'100%': { opacity: '1' }
			})
		},
		changed: {
			display: 'flex',
			justifyContent: 'center',
			alignItems: 'center',
			margin: '-6px',
			fontSize: '20px'
		},
		component: {
			overflow: 'hidden',
			whiteSpace: 'nowrap',
			textOverflow: 'ellipsis',
			fontWeight: 'bold'
		},
		unmountedComponent: {
			fontWeight: 'normal',
			color: 'gray'
		},
		selectedCell: {
			backgroundColor: (0, _color2.default)('lightblue').lighten(.1).hexString()
		},
		methodName: {
			overflow: 'hidden',
			whiteSpace: 'nowrap',
			textOverflow: 'ellipsis'
		},
		renderCount: {
			justifyContent: 'flex-end',
			width: '100%',
			textAlign: 'right'
		},
		warning: {
			justifyContent: 'flex-end',
			width: '100%',
			//minWidth: '20px',
			padding: '3px 0',
			color: 'red',
			fontWeight: 'bold'
		}
	};

	this.updateDimensions = function () {

		// Don't update state after initial rerender;
		// causes UI to flash
		var newState = {};
		if (_this3.state.maxTableHeight !== null) {
			newState.maxTableHeight = _this3.getMaxTableHeight();
		}
		// if (root.getWindow().innerWidth) {
		// 	newState.tableWidth = this.state.tableWidth += (root.getWindow().innerWidth - 900)
		// }
		_this3.setState(newState);
	};

	this.getComponentTableData = function (immutableEntries) {
		// TODO Keep these as immutables for better performance?
		var entries = immutableEntries.toJS();
		var sortedComponentIds = _this3.getSortedComponentIds(entries);
		return sortedComponentIds.map(function (id, ind) {
			var entry = entries[id];
			return {
				isChanged: entry.isChanged,
				name: entry.displayName,
				renderCount: entry.renderCount,
				warningCount: entry.unnecessaryUpdatesPrevented,
				id: id
			};
		});
	};

	this.mergeStyles = function (stylesArray) {
		stylesArray.unshift({});
		return Object.assign.apply(Object, _toConsumableArray(stylesArray));
	};

	this.getRowSelectedStyle = function (id) {
		if (_this3.state.selectedComponentId === id) {
			return _this3.styles.selectedCell;
		}
		return {};
	};

	this.getChangedCell = function (props) {
		var row = _this3.state.componentTableData[props.rowIndex];
		var changedStyle = [_this3.styles.cell, _this3.getRowSelectedStyle(row.id)];
		var isChanged = _this3.props.entries.getIn([row.id, 'isChanged']);

		return _react2.default.createElement(_DataIconCell2.default, _extends({
			isChanged: isChanged
		}, props, {
			style: _this3.mergeStyles(changedStyle),
			childStyle: _this3.styles.changed
		}));
	};

	this.getComponentNameCell = function (props) {
		var row = _this3.state.componentTableData[props.rowIndex];
		var componentStyle = [_this3.styles.component, _this3.styles.cell];
		var isMounted = _this3.props.entries.getIn([row.id, 'isMounted']);
		if (!isMounted) {
			componentStyle.push(_this3.styles.unmountedComponent);
		}
		componentStyle.push(_this3.getRowSelectedStyle(row.id));
		var data = row.name;
		return _react2.default.createElement(_TableCell2.default, _extends({
			data: data
		}, props, {
			style: _this3.mergeStyles(componentStyle),
			childStyle: _this3.styles.methodName
		}));
	};

	this.getRenderCountCell = function (props) {
		var row = _this3.state.componentTableData[props.rowIndex];
		var renderCountStyle = _this3.mergeStyles([_this3.styles.cell, _this3.styles.renderCount, _this3.getRowSelectedStyle(row.id)]);
		var data = row.renderCount;
		return _react2.default.createElement(_TableCell2.default, {
			data: data,
			style: renderCountStyle
		});
	};

	this.getWarningCountCell = function (props) {
		var row = _this3.state.componentTableData[props.rowIndex];
		var warningCount = row.warningCount || '';
		var warningStyle = [_this3.styles.cell, _this3.getRowSelectedStyle(row.id), _this3.styles.warning];
		var tooltip = warningCount ? warningCount + ' unnecessary rerenders prevented' : '';
		var data = warningCount;

		return _react2.default.createElement(_TableCell2.default, {
			data: data,
			style: _this3.mergeStyles(warningStyle),
			title: tooltip
		});
	};

	this.onColumnResizeEnd = function (newColumnWidth, columnKey) {
		_this3.setState(function (_ref) {
			var columnWidths = _ref.columnWidths;
			return {
				columnWidths: _extends({}, columnWidths, _defineProperty({}, columnKey, newColumnWidth))
			};
		});
	};

	this.getMaxTableHeight = function () {
		return _root2.default.getWindow().innerHeight - 60;
	};

	this.getComponents = function () {
		var rowsCount = _this3.state.componentTableData.length;
		var tableHeight = _this3.headerHeight + _this3.rowHeight * rowsCount + 2;
		var maxTableHeight = _this3.state.maxTableHeight;
		if (maxTableHeight && tableHeight > maxTableHeight) {
			tableHeight = maxTableHeight;
		}
		return _react2.default.createElement(
			'div',
			{ style: _this3.styles.tableContainer },
			_react2.default.createElement(
				_fixedDataTable.Table,
				{
					rowsCount: _this3.state.componentTableData.length,
					rowHeight: _this3.rowHeight,
					headerHeight: _this3.headerHeight,
					width: _this3.state.tableWidth,
					overflowY: 'auto',
					overflowX: 'hidden',
					height: tableHeight,
					onRowMouseDown: _this3.handleComponentSelected,
					onColumnResizeEndCallback: _this3.onColumnResizeEnd,
					isColumnResizing: false,
					style: _this3.styles.table
				},
				_react2.default.createElement(_fixedDataTable.Column, {
					columnKey: 'changed',
					header: _react2.default.createElement(Cell, null),
					cell: _this3.getChangedCell,
					width: _this3.state.columnWidths.changed,
					isResizable: true
				}),
				_react2.default.createElement(_fixedDataTable.Column, {
					columnKey: 'name',
					header: _react2.default.createElement(
						Cell,
						null,
						'Name'
					),
					cell: _this3.getComponentNameCell,
					width: _this3.state.columnWidths.name,
					isResizable: true,
					flexGrow: 2
				}),
				_react2.default.createElement(_fixedDataTable.Column, {
					columnKey: 'renderCount',
					header: _react2.default.createElement(
						Cell,
						null,
						'Rendered'
					),
					cell: _this3.getRenderCountCell,
					width: _this3.state.columnWidths.renderCount,
					isResizable: true,
					flexGrow: 1
				}),
				_react2.default.createElement(_fixedDataTable.Column, {
					columnKey: 'warningCount',
					header: _react2.default.createElement(
						Cell,
						null,
						'Warnings'
					),
					cell: _this3.getWarningCountCell,
					width: _this3.state.columnWidths.warningCount,
					isResizable: true
				})
			)
		);
	};

	this.getSortedComponentIds = function (components) {
		return Object.keys(components).sort(function (a, b) {
			var nameA = components[a].displayName.toLowerCase();
			var nameB = components[b].displayName.toLowerCase();
			if (nameA < nameB) {
				return -1;
			}
			if (nameA > nameB) {
				return 1;
			}
			return 0;
		});
	};

	this.handleComponentSelected = function (event, rowIndex) {
		var row = _this3.state.componentTableData[rowIndex];
		_this3.setState({
			selectedComponentId: row.id
		});
		var option = { selectedComponentId: row.id };
		_this3.props.onChange(option);
	};
};

exports.default = (0, _radium2.default)(ComponentList);
module.exports = exports['default'];