'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _color = require('color');

var _color2 = _interopRequireDefault(_color);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _styles = require('../styles/styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Method = function (_Component) {
	_inherits(Method, _Component);

	function Method() {
		_classCallCheck(this, Method);

		var _this = _possibleConstructorReturn(this, (Method.__proto__ || Object.getPrototypeOf(Method)).call(this));

		_this.styles = {
			section: {
				width: '275px',
				margin: '0 10px',
				padding: '10px 10px 5px 10px',
				backgroundColor: 'white',
				boxSizing: 'border-box'
			},
			active: {
				boxShadow: '0 0 10px 6px #2d7188',
				fontWeight: 'bold',
				animation: 'x .7s ease-out',
				animationName: _radium2.default.keyframes({
					'0%': { boxShadow: 'none' },
					'40%': { boxShadow: '0 0 14px 9px ' + (0, _color2.default)('#2d7188').lighten(0.5).hexString() },
					'100%': { boxShadow: '0 0 10px 6px #2d7188' }
				})
			},
			inactive: {
				fontWeight: 'normal',
				boxShadow: 'none'
			},
			methodName: {
				display: 'flex',
				alignItems: 'center',
				flex: '1',
				position: 'relative',
				fontWeight: 'bold',
				wordBreak: 'break-word'
			},
			methodNameWithIcon: {
				marginLeft: '21px'
			},
			methodIcon: {
				position: 'absolute',
				width: '16px',
				height: '16px',
				alignSelf: 'flex-start',
				marginRight: '5px',
				borderRadius: '50%',
				cursor: 'default',
				boxShadow: 'rgba(0, 0, 0, 0.2) -1px -1px 1px inset, rgba(255, 255, 255, 0.5) 1px 1px 1px inset',
				background: 'linear-gradient(to bottom, lightblue 0%, ' + (0, _color2.default)('lightblue').darken(0.5).hexString() + ' 100%)'
			},
			propsAndState: {
				display: 'flex',
				alignItems: 'center'
			},
			propsAndStateChanged: {
				fontWeight: 'bold',
				animation: 'x .7s ease-out',
				animationName: _radium2.default.keyframes({
					'0%': { backgroundColor: 'white' },
					'40%': { backgroundColor: 'yellow' },
					'100%': { backgroundColor: 'white' }
				})
			},
			propsAndStateUnchanged: {
				fontWeight: 'normal',
				color: 'gray'
			},
			line: {
				display: 'flex'
			},
			valueContainer: {
				overflow: 'hidden'
			},
			value: {
				marginLeft: '5px',
				fontWeight: 'normal',
				cursor: 'pointer',
				overflow: 'hidden',
				textOverflow: 'ellipsis',
				whiteSpace: 'nowrap'
			},
			times: {
				display: 'flex',
				justifyContent: 'space-between',
				marginTop: '5px'
			},
			warning: {
				color: 'red'
			},
			message: {
				marginTop: '5px',
				color: 'red'
			},
			setState: {
				display: 'flex',
				alignItems: 'center',
				margin: '5px -5px 0 -5px',
				padding: '5px',
				backgroundColor: 'rgba(76, 175, 80, .5)'
			},
			arrow: {
				display: 'flex',
				justifyContent: 'space-around',
				alignItems: 'center',
				margin: '5px 0 7px 0',
				fontSize: '16px',
				fontWeight: 'bold'
			},
			hidden: {
				opacity: '0'
			},
			input: {
				width: '100%',
				marginLeft: '5px'
			}
		};

		_this.getMethodName = function (methodObj) {
			var args = _this.getArgNames(methodObj).str;
			var name = methodObj.name === 'constructorMethod' ? 'constructor(' + args + ') or getInitialState()' : methodObj.name + '(' + args + ')';
			var methodIcon = '';
			var nameStyle = {};
			if (methodObj.isMethodOverridden) {
				var iconMessage = 'This method exists in the wrapped component';
				methodIcon = _react2.default.createElement('div', { style: _this.styles.methodIcon, title: iconMessage });
				nameStyle = _this.styles.methodNameWithIcon;
			}
			return _react2.default.createElement(
				'div',
				{ id: name + '-name-icon' },
				_react2.default.createElement(
					'div',
					{ style: _this.styles.methodName },
					methodIcon,
					_react2.default.createElement(
						'div',
						{ style: nameStyle },
						name
					)
				)
			);
		};

		_this.getArgNames = function (methodObj) {
			var args = methodObj.args;
			return {
				str: args.join(', '),
				arr: args
			};
		};

		_this.getActivityStyle = function (methodObj) {
			var isActive = methodObj.called;
			var style = isActive ? _this.styles.active : _this.styles.inactive;
			if (methodObj.name === 'render') {
				style.width = '570px';
			}
			return Object.assign({}, _this.styles.section, style);
		};

		_this.getTimesCalled = function (methodObj) {
			var loop = methodObj.isInfiniteLoop ? _react2.default.createElement(
				'div',
				{ style: _this.styles.warning },
				'(infinite loop terminated)'
			) : false;
			return _react2.default.createElement(
				'div',
				{ style: _this.styles.times },
				_react2.default.createElement(
					'div',
					null,
					'Times called: ',
					methodObj.count
				),
				loop
			);
		};

		_this.getPropsAndStates = function (methodObj) {
			var types = ['props', 'state'];
			return types.map(function (type) {
				var propsOrState = methodObj[type];
				// TODO This should be converted to JS Array when mothodObj is converted toJS()
				// but for some reason it isn't
				var values = propsOrState.values.toJS();
				var nameComponents = propsOrState.names.map(function (name, ind) {
					var isSecond = ind > 0;
					return _this.getPropAndStateName(name, type, isSecond);
				});
				// Display both values only if one has changed
				var valueComponents = false;
				if (values.length) {
					(function () {
						var isParallelItemDifferent = propsOrState.arePartnersDifferent;
						var valuesToDisplay = !isParallelItemDifferent && values.length === 2 ? values.slice(0, 1) : values;
						valueComponents = valuesToDisplay.map(function (item, ind) {
							return _this.getPropAndStateValues(valuesToDisplay, ind, type, propsOrState.isChanged);
						});
					})();
				}
				var baseKey = methodObj.name + '-' + type;
				return _react2.default.createElement(
					'div',
					{ key: baseKey, style: _this.styles.propsAndState },
					_react2.default.createElement(
						'div',
						{ key: baseKey + '-label', style: _this.styles.label },
						nameComponents
					),
					_react2.default.createElement(
						'div',
						{ key: baseKey + '-value', style: _this.styles.valueContainer },
						valueComponents
					)
				);
			});
		};

		_this.getPropAndStateName = function (name, type, isSecond) {
			var arrow = isSecond ? '↳' : '';
			return _react2.default.createElement(
				'div',
				{ key: name, style: _this.styles.line },
				_react2.default.createElement(
					'div',
					null,
					arrow,
					name,
					':'
				)
			);
		};

		_this.getPropAndStateValues = function (valuesToDisplay, ind, type, isChanged) {
			var value = valuesToDisplay[ind];
			var isChangedStyle = isChanged && (valuesToDisplay.length === 1 && ind === 0 || ind === 1) ? _this.styles.propsAndStateChanged : _this.styles.propsAndStateUnchanged;
			// this.props.children may contain circular references
			return _react2.default.createElement(
				'div',
				{
					key: 'value-' + ind,
					onClick: _this.handleShowFullText.bind(_this, valuesToDisplay),
					style: [_this.styles.value, _styles2.default[type], isChangedStyle]
				},
				value ? JSON.stringify(value).substr(0, 300) : ''
			);
		};

		_this.handleShowFullText = function (items) {
			_this.props.showFullText(items);
		};

		_this.getUnnecessaryUpdatePrevented = function (methodObj) {
			return methodObj.isUnnecessaryUpdatePrevented ? _react2.default.createElement(
				'div',
				{ style: _this.styles.message },
				'Unnecessary rerender prevented (props and state values have not changed)'
			) : false;
		};

		_this.getDescription = function (methodObj) {
			var description = methodObj.description;
			if (description) {
				return _react2.default.createElement(
					'div',
					{ style: _styles2.default.description },
					description
				);
			} else {
				return false;
			}
		};

		_this.getSetState = function (methodObj) {
			var validMethods = ['constructorMethod', 'componentWillMount', 'componentDidMount', 'componentWillReceiveProps', 'componentDidUpdate'];
			var name = methodObj.name;
			if (!validMethods.includes(name)) {
				return false;
			}
			var label = methodObj.name === 'constructorMethod' ? 'this.state = x' : 'this.setState(x)';
			return _react2.default.createElement(
				'div',
				{ key: label },
				_react2.default.createElement(
					'div',
					{ style: _this.styles.setState },
					label
				),
				_this.getDescription(methodObj)
			);
		};

		_this.getArrow = function (methodObj) {
			if (_this.props.isCompactView) {
				return _react2.default.createElement('div', { style: _this.styles.arrow });
			} else if (methodObj.name === 'render') {
				return _react2.default.createElement(
					'div',
					{ key: methodObj.name + '-arrows', style: _this.styles.arrow },
					_react2.default.createElement(
						'div',
						null,
						'↓'
					),
					_react2.default.createElement(
						'div',
						null,
						'↓'
					)
				);
			} else if (!methodObj.terminal) {
				return _react2.default.createElement(
					'div',
					{ key: methodObj.name + '-arrows', style: _this.styles.arrow },
					'↓'
				);
			} else {
				return _react2.default.createElement(
					'div',
					{ key: methodObj.name + '-arrows', style: [_this.styles.arrow, _this.styles.hidden] },
					'↓'
				);
			}
		};

		_this.handleInputChange = function (event) {
			_this.setState({
				value: event.target.value
			});
		};

		_this.state = {
			showFullText: false
		};
		return _this;
	}

	// TODO need to install react-immutable-proptypes to do this
	// static propTypes = {
	// 	methodObj: PropTypes.shape({
	// 		name: PropTypes.string,
	// 		called: PropTypes.bool,
	// 		count: PropTypes.number,
	// 		props: PropTypes.object,
	// 		state: PropTypes.object,
	// 		args: PropTypes.array
	// 	}).isRequired
	// };


	_createClass(Method, [{
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(nextProps, nextState) {
			return nextProps !== this.props || nextState.showFullText !== this.state.showFullText;
		}

		// TODO Refactor for clarity

	}, {
		key: 'render',
		value: function render() {

			var methodObj = this.props.methodObj.toJS();
			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					'div',
					{ style: this.getActivityStyle(methodObj) },
					this.getMethodName(methodObj),
					this.getTimesCalled(methodObj),
					this.getPropsAndStates(methodObj),
					this.getUnnecessaryUpdatePrevented(methodObj),
					this.getSetState(methodObj)
				),
				this.getArrow(methodObj)
			);
		}
	}]);

	return Method;
}(_react.Component);

Method.propTypes = {
	methodObj: _react.PropTypes.instanceOf(_immutable2.default.Map).isRequired,
	isChanged: _react.PropTypes.object.isRequired,
	showFullText: _react.PropTypes.func.isRequired
};
exports.default = (0, _radium2.default)(Method);
module.exports = exports['default'];