'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _deepEqual = require('deep-equal');

var _deepEqual2 = _interopRequireDefault(_deepEqual);

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

var _root = require('./root.js');

var _root2 = _interopRequireDefault(_root);

var _lifecycleConfig = require('./store/lifecycleConfig');

var _lifecycleConfig2 = _interopRequireDefault(_lifecycleConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function Visible(WrappedComponent) {
	var _class, _temp, _initialiseProps;

	if (process.env.NODE_ENV === 'production') {

		return function (_WrappedComponent) {
			_inherits(ComponentWrapper, _WrappedComponent);

			function ComponentWrapper() {
				_classCallCheck(this, ComponentWrapper);

				return _possibleConstructorReturn(this, (ComponentWrapper.__proto__ || Object.getPrototypeOf(ComponentWrapper)).apply(this, arguments));
			}

			_createClass(ComponentWrapper, [{
				key: 'shouldComponentUpdate',
				value: function shouldComponentUpdate(nextProps, nextState) {

					if (_get(ComponentWrapper.prototype.__proto__ || Object.getPrototypeOf(ComponentWrapper.prototype), 'shouldComponentUpdate', this)) {
						var isSuperAllowingUpdate = _get(ComponentWrapper.prototype.__proto__ || Object.getPrototypeOf(ComponentWrapper.prototype), 'shouldComponentUpdate', this).call(this, nextProps, nextState);
						if (!isSuperAllowingUpdate) {
							return false;
						}
					}

					return !(0, _shallowequal2.default)(nextState, this.state) || !(0, _shallowequal2.default)(nextProps, this.props);
				}
			}]);

			return ComponentWrapper;
		}(WrappedComponent);
	}

	return _temp = _class = function (_WrappedComponent2) {
		_inherits(DevComponentWrapper, _WrappedComponent2);

		function DevComponentWrapper(props) {
			_classCallCheck(this, DevComponentWrapper);

			// if (!this.key) {
			// 	this.key = uuid.v1();
			// }
			var _this2 = _possibleConstructorReturn(this, (DevComponentWrapper.__proto__ || Object.getPrototypeOf(DevComponentWrapper)).apply(this, arguments));

			_initialiseProps.call(_this2);

			_this2.componentName = getComponentName(WrappedComponent);
			_this2.logEntryId = _root2.default.add({
				type: 'ADD_ENTRY',
				key: props.id,
				name: _this2.componentName
			});
			_this2.isRenderingComplete = false;
			_this2.lifecycleLocation = 'mounting';
			_this2.clearCalled();
			_this2.handleLifecycleEvent({
				name: 'constructorMethod',
				props: [props],
				state: []
			});
			var methodObj = {};
			_lifecycleConfig2.default.methodNames.forEach(function (name) {
				var methodName = name === 'constructorMethod' ? 'constructor' : name;
				methodObj[name] = {
					isMethodOverridden: Boolean(_get(DevComponentWrapper.prototype.__proto__ || Object.getPrototypeOf(DevComponentWrapper.prototype), methodName, _this2))
				};
			});
			_root2.default.updateStore({
				type: 'UPDATE_METHODS',
				key: _this2.logEntryId,
				value: methodObj
			});
			return _this2;
		}

		_createClass(DevComponentWrapper, [{
			key: 'componentWillMount',
			value: function componentWillMount() {
				this.handleLifecycleEvent({
					name: 'componentWillMount',
					props: [this.props],
					state: [this.state]
				});
			}
		}, {
			key: 'componentDidMount',
			value: function componentDidMount() {
				this.consoleWindow = _root2.default.getWindow();
				this.handleLifecycleEvent({
					name: 'componentDidMount',
					props: [this.props],
					state: [this.state]
				});
				this.isRenderingComplete = true;
				this.setIsMounted(true);
				_root2.default.updateWindow(this.logEntryId);
			}
		}, {
			key: 'componentWillReceiveProps',
			value: function componentWillReceiveProps(nextProps) {
				this.lifecycleLocation = 'updating';
				this.clearCalled();
				this.handleLifecycleEvent({
					name: 'componentWillReceiveProps',
					props: [this.props, nextProps],
					state: [this.state]
				});
				this.isRenderingComplete = false;
			}
		}, {
			key: 'shouldComponentUpdate',
			value: function shouldComponentUpdate(nextProps, nextState) {

				this.lifecycleLocation = 'updating';
				this.isInfiniteLoop = this.autoRenderCount >= 10;

				var shouldWrappedComponentUpdate = void 0;
				var isSuperAllowingUpdate = null;
				if (_get(DevComponentWrapper.prototype.__proto__ || Object.getPrototypeOf(DevComponentWrapper.prototype), 'shouldComponentUpdate', this)) {
					isSuperAllowingUpdate = _get(DevComponentWrapper.prototype.__proto__ || Object.getPrototypeOf(DevComponentWrapper.prototype), 'shouldComponentUpdate', this).call(this, nextProps, nextState);
				}
				var arePropsEqual = nextProps === this.props;
				var areStatesEqual = nextState === this.state;
				var isWrappedComponentGoingToUpdate = !arePropsEqual || !areStatesEqual;
				if (!isWrappedComponentGoingToUpdate) {
					shouldWrappedComponentUpdate = false;
				} else {
					arePropsEqual = (0, _deepEqual2.default)(nextProps, this.props, { strict: true });
					areStatesEqual = (0, _deepEqual2.default)(nextState, this.state, { strict: true });
					shouldWrappedComponentUpdate = !arePropsEqual || !areStatesEqual;
				}

				var isUnnecessaryUpdatePrevented = isWrappedComponentGoingToUpdate && !shouldWrappedComponentUpdate && isSuperAllowingUpdate !== false;
				if (isUnnecessaryUpdatePrevented) {
					this.incrementUnnecessaryUpdatesPrevented();
				}
				if (this.isRenderingComplete) {
					this.clearCalled();
				}
				this.handleLifecycleEvent({
					name: 'shouldComponentUpdate',
					props: [this.props, nextProps],
					state: [this.state, nextState],
					isUnnecessaryUpdatePrevented: isUnnecessaryUpdatePrevented
				});
				var willUpdate = void 0;
				// TODO Will there be cases where desired behavior sets isInfiniteLoop to true?
				if (this.isInfiniteLoop) {
					willUpdate = false;
				} else if (isSuperAllowingUpdate === false) {
					willUpdate = false;
				} else if (shouldWrappedComponentUpdate) {
					this.isRenderingComplete = false;
					willUpdate = true;
				} else {
					this.isRenderingComplete = true;
					willUpdate = false;
				}
				if (willUpdate) {
					return true;
				} else {
					_root2.default.updateWindow(this.logEntryId);
					return false;
				}
			}
		}, {
			key: 'componentWillUpdate',
			value: function componentWillUpdate(nextProps, nextState) {
				this.handleLifecycleEvent({
					name: 'componentWillUpdate',
					props: [this.props, nextProps],
					state: [this.state, nextState]
				});
			}
		}, {
			key: 'componentDidUpdate',
			value: function componentDidUpdate(prevProps, prevState) {
				this.isRenderingComplete = true;
				this.handleLifecycleEvent({
					name: 'componentDidUpdate',
					props: [prevProps, this.props],
					state: [prevState, this.state]
				});
				_root2.default.updateWindow(this.logEntryId);
			}
		}, {
			key: 'componentWillUnmount',
			value: function componentWillUnmount() {
				this.lifecycleLocation = 'unmounting';
				this.isRenderingComplete = true;
				this.setIsMounted(false);
				this.clearCalled();
				this.handleLifecycleEvent({
					name: 'componentWillUnmount',
					props: [this.props],
					state: [this.state]
				});
				_root2.default.updateWindow(this.logEntryId);
			}

			// Remove props.children because they can contain
			// circular references, which cause problems
			// with cloning and stringifying;
			// This prop value is meant to be opaque
			// and used only internally

		}, {
			key: 'render',
			value: function render() {

				this.incrementRenderCount();
				this.handleLifecycleEvent({
					name: 'render',
					props: [this.props],
					state: [this.state]
				});
				return _get(DevComponentWrapper.prototype.__proto__ || Object.getPrototypeOf(DevComponentWrapper.prototype), 'render', this).call(this);
			}
		}]);

		return DevComponentWrapper;
	}(WrappedComponent), _class.displayName = 'Insure(' + getComponentName(WrappedComponent) + ')', _initialiseProps = function _initialiseProps() {
		var _this3 = this;

		this.logEntryId = null;
		this.autoRenderCount = 0;
		this.isInfiniteLoop = false;
		this.isRenderingComplete = true;
		this.consoleWindow = null;
		this.lifecycleLocation = '';
		this.componentName = '';

		this.handleLifecycleEvent = function (lifecycleData) {
			var count = _root2.default.getFromStore(['entries', _this3.logEntryId, 'methods', lifecycleData.name, 'count']);
			var cleanedProps = lifecycleData.props.map(function (propsValue) {
				return _this3.removePropsChildren(propsValue);
			});
			var method = {
				name: lifecycleData.name,
				called: true,
				count: count + 1,
				props: cleanedProps || [],
				state: lifecycleData.state || [],
				isInfiniteLoop: _this3.isInfiniteLoop,
				isUnnecessaryUpdatePrevented: lifecycleData.isUnnecessaryUpdatePrevented,
				lifecycleLocation: _this3.lifecycleLocation
			};
			_root2.default.updateStore({
				type: 'UPDATE_METHOD',
				entryId: _this3.logEntryId,
				methodName: lifecycleData.name,
				value: method
			});
			console.log('%c' + lifecycleData.name + ' %ccalled in component %c' + _this3.componentName, 'color: green; font-weight: bold;', 'color: black; font-weight: normal;', 'color: blue; font-weight: bold;');
		};

		this.removePropsChildren = function (props) {
			if (!props) {
				return [];
			}
			var newProps = Object.assign({}, props);
			if (newProps.hasOwnProperty('children')) {
				delete newProps.children;
			}
			return newProps;
		};

		this.clearCalled = function () {
			_this3.autoRenderCount = 0;
			var methodObj = {};
			_lifecycleConfig2.default.methodNames.forEach(function (name) {
				methodObj[name] = {
					called: false
				};
			});
			_root2.default.updateStore({
				type: 'UPDATE_METHODS',
				key: _this3.logEntryId,
				value: methodObj
			});
		};

		this.incrementRenderCount = function () {
			_this3.autoRenderCount++;
			_root2.default.updateStore({
				type: 'INCREMENT_VALUE',
				keyPath: [_this3.logEntryId, 'renderCount']
			});
		};

		this.setIsMounted = function (isMounted) {
			_root2.default.updateStore({
				type: 'UPDATE_VALUE',
				keyPath: [_this3.logEntryId, 'isMounted'],
				value: isMounted
			});
		};

		this.incrementUnnecessaryUpdatesPrevented = function () {
			_root2.default.updateStore({
				type: 'INCREMENT_VALUE',
				keyPath: [_this3.logEntryId, 'unnecessaryUpdatesPrevented']
			});
		};
	}, _temp;
}

var getComponentName = function getComponentName(component) {
	return component ? component.displayName || component.name || 'Component' : '';
};

exports.default = Visible;
module.exports = exports['default'];